from typing import Any, Dict, List, Type, TypeVar, cast

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..models.collection_entry_garbage_type import CollectionEntryGarbageType

T = TypeVar("T", bound="CollectionEntry")


@_attrs_define
class CollectionEntry:
    """
    Attributes:
        locations (List[int]):
        garbage_type (CollectionEntryGarbageType):
        date (str):
    """

    locations: List[int]
    garbage_type: CollectionEntryGarbageType
    date: str
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        locations = self.locations

        garbage_type = self.garbage_type.value

        date = self.date

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "locations": locations,
                "garbage_type": garbage_type,
                "date": date,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        locations = cast(List[int], d.pop("locations"))

        garbage_type = CollectionEntryGarbageType(d.pop("garbage_type"))

        date = d.pop("date")

        collection_entry = cls(
            locations=locations,
            garbage_type=garbage_type,
            date=date,
        )

        collection_entry.additional_properties = d
        return collection_entry

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
